'From Cuis 5.0 [latest update: #3893] on 3 October 2019 at 12:58:33 pm'!

!Panel methodsFor: 'geometry' stamp: 'KenD 10/3/2019 12:52:58'!
fitInWorld

	"Try to be contained in the world; return boundingBox"
	| displayRect boundingBox |
	displayRect := RealEstateAgent maximumUsableAreaInWorld: self runningWorld.
	boundingBox  := self morphPositionInWorld extent: self morphExtentInWorld.
	boundingBox := boundingBox translatedToBeWithin: displayRect.
	self morphPositionInWorld: boundingBox origin.
	^boundingBox! !


!Morph methodsFor: '*morphic-misc1' stamp: 'KenD 10/3/2019 09:16:03'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	"Add morph-specific items to the given menu which was invoked by the given hand.  This method provides is invoked both from the halo-menu and from the control-menu regimes."

	aCustomMenu  addLine.
	
	(Smalltalk includesKey: #VisualPropertyEditor)
		ifTrue: [ aCustomMenu addVisualProperties;
				  addLine;
				  add: 'show target halo' action: #addHalo;
				  add: 'show DropTarget for me' action: #showDropTarget
			 ]
		ifFalse: [ aCustomMenu add: 'edit my layoutSpec' action: #editMyLayoutSpec ]! !


!ImagePallet class methodsFor: 'examples' stamp: 'KenD 10/1/2019 13:00:20'!
largerIcons
"
	ImagePallet largerIcons.
"
	| ip sw sortedCollection someIcons |
	
	sortedCollection := SortedCollection sortBlock: [ :a :b | a key < b key].

	{ 'actions'. 'apps'. 'categories'. 'devices'. 'emblems'. 'emotes'. 
			'mimetypes'. 'places'. 'smalltalk'. 'status'. } 
		do: [ :category |
			someIcons := Theme content from: 'Theme' get: {'16x16'. category}.
			someIcons ifNotNil: [someIcons associationsDo: [:assoc| sortedCollection add: assoc]].
		].

	someIcons := (Theme content from: 'Theme' get: {'14x14'. 'buttons'}).
	someIcons ifNotNil: [someIcons associationsDo: [:assoc| sortedCollection add: assoc]].
"	sortedCollection addAll: (iconsCollection select: [ :assoc | assoc isNil not]).
"	
	ip := ImagePallet 
			fromCollection: (sortedCollection collect: [ :assoc | 
				Association key: (assoc key) value: assoc value
			])
			imageFilter: [:form | ImageMorph new image: (form magnifyTo: 64 @ 64)].

	sw := Panel new.
	sw addMorph: ip.
	ip color: sw windowColor paler.
	sw setLabel: 'Pick an Icon';
	showButtonsNamed: #( close collapse ).
	sw openInWorld.
	sw morphExtent: sw minimumExtent. "openInWorld resets extent" 
	^ sw! !

!ImagePallet class methodsFor: 'examples' stamp: 'KenD 10/17/2018 22:58:59'!
namedIcons
"
	ImagePallet namedIcons.
"
	| ip sw iconsCollection sortedCollection |
	iconsCollection := OrderedCollection new. 
	{ 'actions'. 'apps'. 'categories'. 'devices'. 'emblems'. 'emotes'.
	  'mimetypes'. 'places'. 'smalltalk'. 'status'. } do: [ :category |
		iconsCollection addAll: (Theme content from: 'Theme' get: {'16x16'. category}) array.
	].
	sortedCollection := SortedCollection sortBlock: [ :a :b | a key < b key].
	sortedCollection addAll: (iconsCollection select: [ :assoc | assoc isNil not]).
	
	ip := ImagePallet 
			fromCollection: (sortedCollection collect: [ :assoc | 
				Association key: (assoc key) value: assoc value
			])
			imageFilter: [:form | ImageMorph new image: form].

	sw := Panel new.
	sw addMorph: ip.
	ip color: sw windowColor paler.
	sw setLabel: 'Pick an Icon';
	showButtonsNamed: #( close collapse ).
	sw openInWorld.
	sw 	morphExtent: sw minimumExtent.   "openInWorld algorithm resets extent"
	^ sw! !


!Panel class methodsFor: 'instance creation' stamp: 'KenD 4/25/2015 08:43'!
open: model label: aString

	|  window |
	window _ self new.
	window
		model: model;
		buildMorphicWindow.
	aString ifNotNil: [ window setLabel: aString ].
	^ window 
		morphPosition: 
			(RealEstateAgent 
					initialFrameFor: window 
					initialExtent: window defaultExtent 
					world: self runningWorld ) topLeft;
		openInWorld;
		yourself! !

